/* ===============================================
  OPEN CLOSE Menu
============================================= */

function construction_contractor_open_menu() {
  jQuery('button.menu-toggle').addClass('close-panal');
  setTimeout(function(){
    jQuery('nav#main-menu').show();
  }, 100);

  return false;
}

jQuery( "button.menu-toggle").on("click", construction_contractor_open_menu);

function construction_contractor_close_menu() {
  jQuery('button.close-menu').removeClass('close-panal');
  jQuery('nav#main-menu').hide();
}

jQuery( "button.close-menu").on("click", construction_contractor_close_menu);

function construction_contractor_search_show() {
	jQuery(".outer-search").addClass('show');
	jQuery(".outer-search").fadeIn();
}
jQuery( ".search-cont-button").on("click", construction_contractor_search_show);

function construction_contractor_search_hide() {
	jQuery(".outer-search").removeClass('show');
	jQuery(".outer-search").fadeOut();
}
jQuery( ".search-cont-button-close").on("click", construction_contractor_search_hide);


/* ===============================================
  TRAP TAB FOCUS ON MODAL MENU
============================================= */

jQuery('button.close-menu').on('keydown', function (e) {
  if (jQuery("this:focus") && (e.which === 9)) {
    e.preventDefault();
    jQuery(this).blur();
    jQuery('#main-menu ul:first li:first a').focus();
  }
});

jQuery('button.close-menu').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('#main-menu ul:last li:last a').focus()
  }
})

jQuery('#main-menu ul:first li:first a').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('button.close-menu').focus()
  }
})

jQuery(document).ready(function() {
  window.addEventListener('load', (event) => {
      jQuery(".loader").delay(2000).fadeOut("slow");
  });
})
/* ===============================================
  Scroll Top //
============================================= */

jQuery(window).scroll(function () {
  if (jQuery(this).scrollTop() > 100) {
      jQuery('.scroll-up').fadeIn();
  } else {
      jQuery('.scroll-up').fadeOut();
  }
});

jQuery('a[href="#tobottom"]').click(function () {
  jQuery('html, body').animate({scrollTop: 0}, 'slow');
  return false;
});

(function( $ ) {
  $(window).scroll(function(){
      var sticky = $('.sticky-header'),
      scroll = $(window).scrollTop();

      if (scroll >= 100) sticky.addClass('fixed-header');
      else sticky.removeClass('fixed-header');
    });
  })( jQuery );

  /* ===============================================
  Search pop up
============================================= */

jQuery('.search-cont-button-close').on('keydown', function (e) {
  if (jQuery("this:focus") && (e.which === 9)) {
    e.preventDefault();
    jQuery(this).blur();
    jQuery('.inner-search form input').focus();
  }
});

jQuery('.inner-search form input').on('keydown', function (event) {
  if (event.shiftKey && event.keyCode == 9) {
    event.preventDefault();
    jQuery(this).blur();
    jQuery('.search-cont-button-close').focus()
  }
})

/* ===============================================
  Custom Cursor
============================================= */

const construction_contractor_customCursor = {
  init: function () {
    this.construction_contractor_customCursor();
  },
  isVariableDefined: function (el) {
    return typeof el !== "undefined" && el !== null;
  },
  select: function (selectors) {
    return document.querySelector(selectors);
  },
  selectAll: function (selectors) {
    return document.querySelectorAll(selectors);
  },
  construction_contractor_customCursor: function () {
    const construction_contractor_cursorDot = this.select(".cursor-point");
    const construction_contractor_cursorOutline = this.select(".cursor-point-outline");
    if (this.isVariableDefined(construction_contractor_cursorDot) && this.isVariableDefined(construction_contractor_cursorOutline)) {
      const cursor = {
        delay: 8,
        _x: 0,
        _y: 0,
        endX: window.innerWidth / 2,
        endY: window.innerHeight / 2,
        cursorVisible: true,
        cursorEnlarged: false,
        $dot: construction_contractor_cursorDot,
        $outline: construction_contractor_cursorOutline,

        init: function () {
          this.dotSize = this.$dot.offsetWidth;
          this.outlineSize = this.$outline.offsetWidth;
          this.setupEventListeners();
          this.animateDotOutline();
        },

        updateCursor: function (e) {
          this.cursorVisible = true;
          this.toggleCursorVisibility();
          this.endX = e.clientX;
          this.endY = e.clientY;
          this.$dot.style.top = `${this.endY}px`;
          this.$dot.style.left = `${this.endX}px`;
        },

        setupEventListeners: function () {
          window.addEventListener("load", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          construction_contractor_customCursor.selectAll("a, button").forEach((el) => {
            el.addEventListener("mouseover", () => {
              this.cursorEnlarged = true;
              this.toggleCursorSize();
            });
            el.addEventListener("mouseout", () => {
              this.cursorEnlarged = false;
              this.toggleCursorSize();
            });
          });

          document.addEventListener("mousedown", () => {
            this.cursorEnlarged = true;
            this.toggleCursorSize();
          });
          document.addEventListener("mouseup", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          document.addEventListener("mousemove", (e) => {
            this.updateCursor(e);
          });

          document.addEventListener("mouseenter", () => {
            this.cursorVisible = true;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          });

          document.addEventListener("mouseleave", () => {
            this.cursorVisible = false;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          });
        },

        animateDotOutline: function () {
          this._x += (this.endX - this._x) / this.delay;
          this._y += (this.endY - this._y) / this.delay;
          this.$outline.style.top = `${this._y}px`;
          this.$outline.style.left = `${this._x}px`;

          requestAnimationFrame(this.animateDotOutline.bind(this));
        },

        toggleCursorSize: function () {
          if (this.cursorEnlarged) {
            this.$dot.style.transform = "translate(-50%, -50%) scale(0.75)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1.6)";
          } else {
            this.$dot.style.transform = "translate(-50%, -50%) scale(1)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1)";
          }
        },

        toggleCursorVisibility: function () {
          if (this.cursorVisible) {
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          } else {
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          }
        },
      };
      cursor.init();
    }
  },
};
construction_contractor_customCursor.init();

/* ===============================================
  Progress Bar
============================================= */
const construction_contractor_progressBar = {
  init: function () {
      let construction_contractor_progressBarDiv = document.getElementById("elemento-progress-bar");

      if (construction_contractor_progressBarDiv) {
          let construction_contractor_body = document.body;
          let construction_contractor_rootElement = document.documentElement;

          window.addEventListener("scroll", function (event) {
              let construction_contractor_winScroll = construction_contractor_body.scrollTop || construction_contractor_rootElement.scrollTop;
              let construction_contractor_height =
              construction_contractor_rootElement.scrollHeight - construction_contractor_rootElement.clientHeight;
              let construction_contractor_scrolled = (construction_contractor_winScroll / construction_contractor_height) * 100;
              construction_contractor_progressBarDiv.style.width = construction_contractor_scrolled + "%";
          });
      }
  },
};
construction_contractor_progressBar.init();

/* ===============================================
   sticky copyright
============================================= */

window.addEventListener('scroll', function() {
  var construction_contractor_footer = document.querySelector('.sticky-copyright');
  if (!construction_contractor_footer) return; 

  var construction_contractor_scrollTop = window.scrollY || document.documentElement.construction_contractor_scrollTop;

  if (construction_contractor_scrollTop >= 100) {
    construction_contractor_footer.classList.add('active-sticky');
  }
});

/* ===============================================
   sticky sidebar
============================================= */

window.addEventListener('scroll', function () {
  var construction_contractor_sidebar = document.querySelector('.sidebar-sticky');
  if (!construction_contractor_sidebar) return;

  var construction_contractor_scrollTop = window.scrollY || document.documentElement.scrollTop;
  var construction_contractor_windowHeight = window.innerHeight;
  var construction_contractor_documentHeight = document.documentElement.scrollHeight;

  var construction_contractor_isBottom = construction_contractor_scrollTop + construction_contractor_windowHeight >= construction_contractor_documentHeight - 100;

  if (construction_contractor_scrollTop >= 100 && !construction_contractor_isBottom) {
    construction_contractor_sidebar.classList.add('sidebar-fixed');
  } else {
    construction_contractor_sidebar.classList.remove('sidebar-fixed');
  }
});